import os, sys
from Globals import DTMLFile, package_home
from ImageFile import ImageFile
from Products.PageTemplates.PageTemplateFile import PageTemplateFile

ext_map = {
    '.gif': (ImageFile, 1),
    '.jpg': (ImageFile, 1),
    '.jpeg': (ImageFile, 1),
    '.png': (ImageFile, 1),
    '.dtml': (DTMLFile, 0),
    '.pt': (PageTemplateFile, 1),
    }

def setup(g):
    home = package_home(g)
    m = sys.modules[g['__name__']]
    m.misc_ = misc = {}
    m.product = ProductInfo(m, home)
    
    splitext = os.path.splitext
    misc_dir = os.path.join(home, 'misc')
    for file in os.listdir(misc_dir):
       base, ext = splitext(file) 
       FileType, wholename = ext_map.get(ext, (None, None))
       if FileType is not None:
           misc[base] = FileType(wholename and file or base, misc_dir)

class ProductInfo:
    def __init__(self, module, home):
        self.module = module
        self.home = home
        
    def add_skin(self, Class, def_ext=''):
        skin_dir = os.path.join(self.home, 'skin', Class.__name__)
        splitext = os.path.splitext
        for file in os.listdir(skin_dir):
           base, ext = splitext(file) 
           FileType, wholename = ext_map.get(ext or def_ext, (None, None))
           if FileType is not None:
               setattr(Class, base, 
                       FileType(wholename and file or base, skin_dir))
